<?php

/**
 * @file
 * Configuration for Views UI permissions.
 */

/**
 * Settings callback.
 */
function views_ui_perm_settings() {

  $options = views_ui_perm_available_fields();
  $ui_options = array();
  foreach ($options as $option) {
    $ui_options[$option['key']] = $option['name'];
  }

  $form['views_ui_permissions'] = array(
    '#type' => 'checkboxes',
    '#options' => $ui_options,
    '#default_value' => variable_get('views_ui_permissions', views_ui_perm_default_values($options)),
  );

  $form = system_settings_form($form);

  $form['#theme'] = 'views_ui_perm_settings';
  return $form;
}

/**
 * Theme settings form.
 */
function theme_views_ui_perm_settings($form) {
  $i = 0;
  $options = views_ui_perm_available_fields();

  $output = '<div>'. t('Views UI permissions lets you restrict access to users with the <em>restricted views permissions</em> to edit certain options in the views interface. Toggle the checkbox of any views option to enable access. Disabled automatically:<ul><li>Adding or removing displays.</li><li>Access to any other views option (add, delete, clone, export, import and tools).</li></ul>') .'</div>';

  foreach (element_children($form['views_ui_permissions']) as $key) {
    if ($options[$i]['div_open']) {
      $output .= '<div style="float: left; border-left:1px solid #ccc; margin-top: 10px; padding: 10px 10px 0 10px;"><h3>'. $options[$i]['div_title'] .'</h3>';
    }
    if ($options[$i]['div_title'] && !$options[$i]['div_open']) {
      $output .= '<h3>'. $options[$i]['div_title'] .'</h3>';
    }
    $output .= drupal_render($form['views_ui_permissions'][$key]);
    if ($options[$i]['div_close']) {
      $output .= '</div>';
    }
    $i++;
  }

  $output .= '<div style="clear: both"></div>';
  $output .= drupal_render($form);
  return $output;
}
